(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define('@studiohyperdrive/ngx-utils', ['exports', '@angular/common', '@angular/core', 'rxjs'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.studiohyperdrive = global.studiohyperdrive || {}, global.studiohyperdrive['ngx-utils'] = {}), global.ng.common, global.ng.core, global.rxjs));
}(this, (function (exports, i1, i0, rxjs) { 'use strict';

    // @dynamic
    var WindowService = /** @class */ (function () {
        function WindowService(document, 
        // tslint:disable-next-line: ban-types
        platformId) {
            var _this = this;
            this.document = document;
            this.platformId = platformId;
            this.width$ = new rxjs.BehaviorSubject(1200);
            this.scrollingUp$ = new rxjs.BehaviorSubject(true);
            this.currentScrollPosition = 0;
            if (this.isBrowser() && this.hasDocument()) {
                this.window = this.document.defaultView;
                this.document.addEventListener('scroll', this.handleContentScroll.bind(this));
                this.width$.next(this.window.innerWidth);
                this.window.addEventListener('resize', function () {
                    if (_this.window.innerWidth && _this.width$.getValue()) {
                        _this.width$.next(_this.window.innerWidth);
                    }
                });
            }
        }
        WindowService.prototype.scrollTo = function (offset) {
            if (offset === void 0) { offset = 0; }
            if (!this.window) {
                return;
            }
            this.window.scrollTo(0, offset);
        };
        WindowService.prototype.hasDocument = function () {
            return !!this.document;
        };
        WindowService.prototype.isBrowser = function () {
            return i1.isPlatformBrowser(this.platformId);
        };
        WindowService.prototype.handleContentScroll = function () {
            if (window.pageYOffset > this.currentScrollPosition) {
                this.scrollingUp$.next(false);
            }
            else {
                this.scrollingUp$.next(true);
            }
            this.currentScrollPosition = window.pageYOffset;
        };
        return WindowService;
    }());
    WindowService.ɵprov = i0.ɵɵdefineInjectable({ factory: function WindowService_Factory() { return new WindowService(i0.ɵɵinject(i1.DOCUMENT), i0.ɵɵinject(i0.PLATFORM_ID)); }, token: WindowService, providedIn: "root" });
    WindowService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root',
                },] }
    ];
    WindowService.ctorParameters = function () { return [
        { type: Document, decorators: [{ type: i0.Inject, args: [i1.DOCUMENT,] }] },
        { type: String, decorators: [{ type: i0.Inject, args: [i0.PLATFORM_ID,] }] }
    ]; };

    var SubscriptionService = /** @class */ (function () {
        function SubscriptionService() {
            this.destroyed$ = new rxjs.Subject();
        }
        SubscriptionService.prototype.ngOnDestroy = function () {
            this.destroyed$.next(true);
            this.destroyed$.complete();
        };
        return SubscriptionService;
    }());
    SubscriptionService.decorators = [
        { type: i0.Injectable }
    ];

    var UtilsModule = /** @class */ (function () {
        function UtilsModule() {
        }
        return UtilsModule;
    }());
    UtilsModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [],
                    imports: [],
                    providers: [WindowService],
                    exports: [],
                },] }
    ];

    /*
     * Public API Surface of utils
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.SubscriptionService = SubscriptionService;
    exports.UtilsModule = UtilsModule;
    exports.WindowService = WindowService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=studiohyperdrive-ngx-utils.umd.js.map
